print "Content-type: text/html\n\n";

# fil name:  make_dir.cgi
# type:      perl program
# last rev:  18.08.1998
# author:    Bjarni Thor Pjetursson
# email:     pjetursson@hotmail.com
#
# Description:
# Part of the FileTrans System.
# Developed for WWW and only works in conjunction with the other parts
#
# The following code is divided into parts:
# var def, var import, var manipulation, control, altering, storing, output


# VAR DEF:
#
$REASON = "make_dir.cgi";
require "main.cgi";


# VAR IMPORT:
#
$cgi_lib'maxdata = 300;          # max input now accepted by cgi-lib.pl
require "misc.cgi";
$ret = &ReadParse;
$DIRNAME       = $in{'dirname'};
$LEVEL         = $in{'level'};
$NOTE          = $in{'note'};

# VAR MANIPULATION:
#
$DIRNAME       = "/$DIRNAME";
if ($DIRNAME =~ /(\w+)\.(\w+)/i) {$DIRNAME = "$1.$2";}
else {$DIRNAME =~ /(\w+)/i; $DIRNAME = "$1";} # meta chars now removed
$DIRECTORY     = "$FULL_PATH/$DIRNAME";
$NOTE          =~ s/</&lt\;/g;         # special chars changed to html format
$NOTE          =~ s/>/&gt\;/g;
$NOTE          =~ s//&aelig\;/g;
$NOTE          =~ s//&AElig\;/g;
$NOTE          =~ s//&oslash\;/g;
$NOTE          =~ s//&Oslash\;/g;
$NOTE          =~ s//&aring\;/g;
$NOTE          =~ s//&Aring\;/g;
$NOTE          =~ s//&uml\;/g;
$NOTE          =~ s/"/&quot\;/g;
$NOTE          =~ s//&curren\;/g;
# $NOTE          =~ s/&/&amp\;/g; ### Done by cgi-lib.pl
$NOTE          =~ s//&acute\;/g;
$NOTE          =~ s//&pound\;/g;
$NOTE          =~ s//&frac12\;/g;
$NOTE          =~ s//&sect\;/g;
if ($LEVEL =~ /level 1/i) {$LEVEL = "level 1"}
if ($LEVEL =~ /level 2/i) {$LEVEL = "level 2"}
if ($LEVEL =~ /level 3/i) {$LEVEL = "level 3"}
if ($LEVEL =~ /level 4/i) {$LEVEL = "level 4"}
if ($LEVEL =~ /level 5/i) {$LEVEL = "level 5"}


# CONTROL:
#
&CgiDie("No name specified - try again") if !$DIRNAME;
&CgiDie("Sorry, $DIRECTORY is used - try another") if -e $DIRECTORY;
&CgiDie("Sorry, no permissions given for the directory") if !$LEVEL;

# ALTERING:
#
########### files.html is being altered: ###########
open (CONTENTS, "< $FULL_PATH/files.html") || &CgiDie ("Couldn't open files.html");
open (CONTENTS_TMP, ">> $FULL_PATH/files.temp") || &CgiDie ("Couldn't open temp file");
flock (CONTENTS, 2);
flock (CONTENTS_TMP, 2);

$CONTENTS = <CONTENTS>;
print CONTENTS_TMP "$CONTENTS";

LOOP:
while ($CONTENTS = <CONTENTS>)
{
if ($CONTENTS =~ /\<! DIR-END\>/i) {
$CONTENTS =~ s/\<! DIR-END\>/\<CENTER\>\<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=0 WIDTH=100%\>\<TR\>
\<TD WIDTH=5%\>\<A HREF=$FULL_URL\/$DIRNAME\/files.html\>\<IMG SRC=$PIXELS_URL\/folder.gif HEIGHT=22 WIDTH=20 BORDER=0\>\<\/A\>\<\/TD\>
\<TD WIDTH=50%\>\<A HREF=$FULL_URL\/$DIRNAME\/files.html\>$DIRNAME\<\/A\> ($LEVEL)\<BR\>
\<I\>$NOTE\<\/I\>\<\/TD\>\<TD WIDTH=5%\>\<\/TD\>
\<TD WIDTH=20%\>$MTH $DD $YEAR\<\/TD\>
\<TD WIDTH=20%\>$REMOTE_HOST\<\/TD\>
\<\/TR\>\<\/TABLE\>\<\/CENTER\>

\<! DIR-END\>/i}

print CONTENTS_TMP "$CONTENTS";
next LOOP;
}

print `mv $FULL_PATH/files.temp $FULL_PATH/files.html`;
flock (CONTENTS, 8);
flock (CONTENTS_TMP, 8);
close CONTENTS;
close CONTENTS_TMP;

# STORING:
#
############ Lib is being made: ############
print `mkdir $DIRECTORY`;
print `cp $FILES_PATH/files.skb $DIRECTORY/files.html`;
print `ln -s $FULL_PATH/upload.html $DIRECTORY`;
print `ln -s $FULL_PATH/make_dir.html $DIRECTORY`;
print `ln -s $FULL_PATH/del_file.html $DIRECTORY`;
print `ln -s $FULL_PATH/del_dir.html $DIRECTORY`;
print `ln -s $FULL_PATH/leftcell.html $DIRECTORY`;
print `ln -s $FILES_PATH/index.html $DIRECTORY/index.html`;

############ .htaccess is being made: ############
open (HTFILE, ">> $DIRECTORY/.htaccess") || CgiDie ("Couldn't create password file\n");

print HTFILE "AuthName $SYS_NAME, $LEVEL\n";
print HTFILE "AuthType Basic\n";
print HTFILE "AuthUserFile $PASSWD_PATH/.htpasswd\n";
print HTFILE "AuthGroupFile $PASSWD_PATH/.groupfile\n";
print HTFILE "DefaultType application/octet-stream\n\n";
if ($LEVEL =~ /level 1/i) {print HTFILE "require group level1\n\n"}
if ($LEVEL =~ /level 2/i) {print HTFILE "require group level1 level2\n\n"}
if ($LEVEL =~ /level 3/i) {print HTFILE "require group level1 level2 level3\n\n"}
if ($LEVEL =~ /level 4/i) {print HTFILE "require group level1 level2 level3 level4\n\n"}
if ($LEVEL =~ /level 5/i) {print HTFILE "require group level1 level2 level3 level4 level5\n\n"}

############ The new files.html is altered: #############
open (NEW_CONTENTS, "< $DIRECTORY/files.html") || CgiDie ("Couldn't open files.html\n");
open (NEW_CONTENTS_TMP, ">> $DIRECTORY/files.temp") || CgiDie ("Couldn't open temp file\n");

$CONTENTS = <NEW_CONTENTS>;
print NEW_CONTENTS_TMP "$CONTENTS";

LOOP:
while ($CONTENTS = <NEW_CONTENTS>)
{
$STI = "$PATH/$DIRNAME"; $STI =~ s/\/\//\//ig; $STI =~ s/\/\//\//ig;
if ($CONTENTS =~ /Index of:/) {
$CONTENTS =~ s/Index of:/($LEVEL) Index of:$STI/i}

print NEW_CONTENTS_TMP "$CONTENTS";
next LOOP;
}

print `mv $DIRECTORY/files.temp $DIRECTORY/files.html`;
close NEW_CONTENTS;
close NEW_CONTENTS_TMP;

# OUTPUT TO BROWSER:
#
print <<WEB_PAGE;
<html>
<body text="#000080" bgcolor="#FFFFFF" link="#0000EE" vlink="#551A8B" alink="#FF0000" 
onLoad="parent.bodycell.location.href='$FULL_URL/files.html'; return true;">
<BR>
<h3><center>New directory: $DIRNAME
</center>
</body>
</html>
WEB_PAGE
