#!/coll/local/bin/perl
print "Content-type: text/html\n\n";
print "<PRE>";

# fil name:  setup.cgi
# type:      perl program
# last rev:  27.05.1997
# author:    Bjarni Thor Pjetursson
# email:     3288@et.aarhus.ih.dk
#
# Description:
# Part of the FileTrans System.
# Developed for WWW and only works in conjunction with the other parts
#
# The program is run to modify the cgi and html files.
# It uses "main.cgi" to determine the users settings.


# VAR DEF:
#
# To make it easier to modify the files, please tell me the old references,
# so I can search for these and replace them with the ones given in "main.cgi".
#
# If this is the first time you run setup.cgi, no changes are needed here! 
#
$OLD_SYS_NAME    = "The File Transfer System";
$OLD_SCRIPTS_URL = "http://www.btp.com/filetrans/cgi";
$OLD_PIXELS_URL  = "http://www.btp.com/filetrans/pixels";
$OLD_FILES_URL   = "http://www.btp.com/filetrans/files";
#
#
# Here you can customize the names for the different password levels:
#
$OLD_LEVEL1_TXT = "level 1: Not defined";
$OLD_LEVEL2_TXT = "level 2: Not defined";
$OLD_LEVEL3_TXT = "level 3: Not defined";
$OLD_LEVEL4_TXT = "level 4: Not defined";
$OLD_LEVEL5_TXT = "level 5: Not defined";
#
$LEVEL1_TXT     = "level 1: owners";          # These text strings MUST contain
$LEVEL2_TXT     = "level 2: trustees";        # "level x:". The string is used by
$LEVEL3_TXT     = "level 3: member";          # by the scripts to determine the 
$LEVEL4_TXT     = "level 4: trial member";    # permissions. The rest of the string
$LEVEL5_TXT     = "level 5: public";          # may be changed freely.


########################################################################################
#                                                                                      #
#    #    THESE VARS MUST BE VERIFIED BEFORE RUNNING THE PROGRAM!!!                    #
#   ###                                                                                #
#  # # #  The program uses your settings from "cgi/main.cgi" and above to modify       #
#    #    references in the appropriate html and cgi files.                            #
#    #                                                                                 #
#    #    This is he fist program to run after unpacking the system and modifying      #
#    #    the vars above and in "cgi/main.cgi".                                        #
#    #                                                                                 #
#    #    Remember to change the first line in this file to match the location         #
#    #    of your Perl enterpreter. Otherwise the program can't execute.               #
#                                                                                      #
########################################################################################

# BUILD MAIN.CGI:
#
print "\n Building main.cgi:\n\n";
print `cat cgi/head.txt > cgi/main.cgi`;
print `cat setup.txt >> cgi/main.cgi`;
print `cat cgi/botm.txt >> cgi/main.cgi`;
print `rm cgi/head.txt setup.txt cgi/botm.txt`;

require "cgi/main.cgi";
print "\n Done!\n\n";

# SEARCH AND REPLACE REFERENCES IN HTML FILES:
#
print "\n Search and replace references in HTML files:\n\n";

&MODIFY_HTML ("files/del_dir.html");
print "files/del_dir.html modified\n";

&MODIFY_HTML ("files/del_file.html");
print "files/del_file.html modified\n";

&MODIFY_HTML ("files/make_dir.html");
print "files/make_dir.html modified\n";

&MODIFY_HTML ("files/upload.html");
print "files/upload.html modified\n";

&MODIFY_HTML ("files/files.html");
print "files/files.html modified\n";

&MODIFY_HTML ("files/files.skb");
print "files/files.skb modified\n";

&MODIFY_HTML ("files/leftcell.html");
print "files/leftcell.html modified\n";

&MODIFY_HTML ("files/help.html");
print "files/help.html modified\n";

&MODIFY_HTML ("files/index.html");
print "files/index.html modified\n";

&MODIFY_HTML ("cgi/index.html");
print "cgi/index.html modified\n";

&MODIFY_HTML ("pixels/index.html");
print "pixels/del_dir.html modified\n";

&MODIFY_HTML ("htpasswd/index.html");
print "htpasswd/del_dir.html modified\n";

print `chmod 644 files/*`;
print `chmod uog+rw files/files.html`;   # when web server runs as
print `chmod uog+rw files`;              # user "nobody"
print `chmod 644 index.html`;
print `chmod 644 cgi/index.html`;
print `chmod 644 pixels/index.html`;
print `chmod 644 htpasswd/index.html`;


# GET PERL PATH
#
print "\n Get Perl path:\n\n";
print `cp setup.cgi temp_file`;
open (TEMP_FILE, "cat temp_file |") || &CgiDie ("Couldn't open temp_file");
$REF = <TEMP_FILE>; chop $REF;
print `rm temp_file`;
print "Got $REF from setup.cgi\n";


# PUT PERL REFERENCES IN CGI SCRIPTS:
#
print "\n Putting references in CGI scripts:\n\n";
&MODIFY_CGI ("cgi/del_dir.cgi");

print "cgi/del_dir.cgi modified\n";
&MODIFY_CGI ("cgi/del_file.cgi");

print "cgi/del_file.cgi modified\n";
&MODIFY_CGI ("cgi/make_dir.cgi");

print "cgi/make_dir.cgi modified\n";
&MODIFY_CGI ("cgi/upload.cgi");

print "cgi/upload.cgi modified\n";
&MODIFY_CGI ("cgi/update.cgi");

print "cgi/update.cgi modified\n";
&MODIFY_CGI ("cgi/testmain.cgi");

print "cgi/testmain.cgi modified\n";

print "\n MODIFY COMPLETE! \n\n";

print `chmod 755 cgi/*.cgi`;


# MOVE FILES:
#
unless (-e $SCRIPTS_PATH) {print `mv cgi $SCRIPTS_PATH`; 
    print "\n\n Your scripts are moved to $SCRIPTS_PATH acc to setup.txt \n\n";}

unless (-e $PASSWD_PATH) {print `mv htpasswd $PASSWD_PATH`;
    print "\n\n Your passwd files are moved to $PASSWD_PATH acc to setup.txt \n\n";}


print `echo AuthName $SYS_NAME, level 5 > files/.htaccess`;
print `echo AuthType Basic >> files/.htaccess`;
print `echo AuthUserFile $PASSWD_PATH/.htpasswd >> files/.htaccess`;
print `echo AuthGroupFile $PASSWD_PATH/.groupfile >> files/.htaccess`;
print `echo DefaultType application/octet-stream >> files/.htaccess`;
print `echo >> files/.htaccess`;
print `echo require group level1 level2 level3 level4 level5 >> files/.htaccess`;
print `echo >> files/.htaccess`;

print `rm setup.cgi`;
print `rm access.txt`;

#################################################################################


# MODIFY_HTML, SUBROUTINE
#
sub MODIFY_HTML
{
   local ($HTML_FILE) = pop(@_);
   open (HTML_FILE, "cat $HTML_FILE |") || &CgiDie ("Couldn't open $HTML_FILE");

   $CONTENTS = <HTML_FILE>; chop $CONTENTS;
   print `echo "$CONTENTS" > temp_file`;
   while ($CONTENTS = <HTML_FILE>)
   {
      chop $CONTENTS;
      $CONTENTS =~ s/\"//ig;
      $CONTENTS =~ s/$OLD_SYS_NAME/$SYS_NAME/ig;
      $CONTENTS =~ s/$OLD_SCRIPTS_URL/$SCRIPTS_URL/ig;
      $CONTENTS =~ s/$OLD_PIXELS_URL/$PIXELS_URL/ig;
      $CONTENTS =~ s/$OLD_FILES_URL/$FILES_URL/ig;
      $CONTENTS =~ s/$OLD_LEVEL1_TXT/$LEVEL1_TXT/ig;
      $CONTENTS =~ s/$OLD_LEVEL2_TXT/$LEVEL2_TXT/ig;
      $CONTENTS =~ s/$OLD_LEVEL3_TXT/$LEVEL3_TXT/ig;
      $CONTENTS =~ s/$OLD_LEVEL4_TXT/$LEVEL4_TXT/ig;
      $CONTENTS =~ s/$OLD_LEVEL5_TXT/$LEVEL5_TXT/ig;
      print `echo "$CONTENTS" >> temp_file`;
   }
   print `mv temp_file $HTML_FILE`;
}


# MODIFY_CGI
#
sub MODIFY_CGI
{
   local ($CGI_FILE) = pop(@_);

   print `echo "$REF" > temp_file`;
   print `cat $CGI_FILE >> temp_file`;
   print `mv temp_file $CGI_FILE`;
}
